var that = this;
function __skpm_run (key, context) {
  that.context = context;

var exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.onSelectionChanged = onSelectionChanged;

exports['default'] = function () {};

var _helper = __webpack_require__(1);

var _helper2 = _interopRequireDefault(_helper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function onSelectionChanged(context) {
    _helper2['default'].setContext(context);

    var webUIs = _helper2['default'].getWebViewReference();

    if (webUIs.length > 0) {
        var selectedLayers = context.actionContext.document.selectedLayers().layers();
        var artboards = _helper2['default'].getSelectedArtboards(selectedLayers);
        var details = [];

        for (var a = 0; a < artboards.length; a++) {
            details.push({
                name: artboards[a].name() + '',
                objectID: artboards[a].objectID() + ''
            });
        }

        for (var r = 0; r < webUIs.length; r++) {
            webUIs[r].eval("__sketchAPI('eventSelectionChanged', " + JSON.stringify(details) + ")");
        }
    }
}

/***/ }),
/* 1 */
/***/ (function(module, exports) {

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Helper = function () {
    function Helper() {
        _classCallCheck(this, Helper);
    }

    _createClass(Helper, null, [{
        key: 'getWebViewReference',
        value: function () {
            function getWebViewReference() {
                var threadDictionary = NSThread.mainThread().threadDictionary();
                var panel = threadDictionary['preely-sketch-plugin.webview'];

                if (panel === null) return null;

                var subviews = panel.contentView().subviews();

                refs = [];
                for (var v = 0; v < subviews.length; v++) {
                    if (subviews[v].className() == 'WebView') {
                        refs.push({
                            panel: panel,
                            eval: subviews[v].stringByEvaluatingJavaScriptFromString,
                            webView: subviews[v]
                        });
                    }
                }

                return refs;
            }

            return getWebViewReference;
        }()
    }, {
        key: 'getSelectedArtboards',
        value: function () {
            function getSelectedArtboards(selection) {
                var enumerator = selection.objectEnumerator();
                var artboards = {};

                while (msLayer = enumerator.nextObject()) {
                    if (!artboards.hasOwnProperty(msLayer.parentArtboard().objectID())) {
                        artboards[msLayer.parentArtboard().objectID()] = msLayer.parentArtboard();
                    }
                }

                return Object.values(artboards);
            }

            return getSelectedArtboards;
        }()
    }, {
        key: 'getSelectedArtboardsCount',
        value: function () {
            function getSelectedArtboardsCount(selection) {
                return Helper.getSelectedArtboards(selection).length;
            }

            return getSelectedArtboardsCount;
        }()
    }, {
        key: 'artboardsInSelection',
        value: function () {
            function artboardsInSelection(selection) {
                return Helper.getSelectedArtboardsCount(selection) > 0;
            }

            return artboardsInSelection;
        }()
    }, {
        key: 'getArtboardsInPage',
        value: function () {
            function getArtboardsInPage(page) {
                var artboardObjects = page.artboards().objectEnumerator();
                var artboards = [];

                while (artboard = artboardObjects.nextObject()) {
                    artboards.push(artboard);
                }

                return artboards;
            }

            return getArtboardsInPage;
        }()
    }, {
        key: 'serializeArtboards',
        value: function () {
            function serializeArtboards(ctx) {
                var document = ctx.document;

                var selectedLayers = ctx.document.selectedLayers().layers();
                var artboards = Helper.getSelectedArtboards(selectedLayers);

                if (artboards.length === 0) {
                    artboards = Helper.getArtboardsInPage(document.currentPage());
                }

                var images = [];

                for (var i = 0; i < artboards.length; i++) {
                    var artboard = artboards[i];

                    var filename = artboard.name() + ".png";
                    var path = NSTemporaryDirectory() + artboard.objectID() + '.png';
                    //save file to temp path
                    var request = MSExportRequest['new']();
                    request.format = 'png';
                    request.includeArtboardBackground = true;
                    request.rect = artboard.absoluteInfluenceRect();
                    request.scale = 2;

                    document.saveExportRequest_toFile(request, path);

                    var image = NSData.alloc().initWithContentsOfURL(NSURL.fileURLWithPath(path));
                    var imageData = image.base64EncodedStringWithOptions(0);

                    images.push({
                        name: filename,
                        data: 'data:image/png;base64,' + imageData
                    });
                }

                return images;
            }

            return serializeArtboards;
        }()
    }]);

    return Helper;
}();

exports['default'] = Helper;

/***/ })
/******/ ]);
  if (key === 'default' && typeof exports === 'function') {
    exports(context);
  } else {
    exports[key](context);
  }
}
that['onSelectionChanged'] = __skpm_run.bind(this, 'onSelectionChanged');
that['onRun'] = __skpm_run.bind(this, 'default')
