var that = this;
function __skpm_run (key, context) {
  that.context = context;

var exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports['default'] = function (context) {

    var defaultPreferences = {
        authToken: '',
        lastSelectedPrototype: ''
    };

    var options = {
        identifier: 'preely-sketch-plugin.webview', // to reuse the UI
        x: 0,
        y: 0,
        width: 950,
        height: 650,
        background: NSColor.whiteColor(),
        onlyShowCloseButton: true,
        title: 'Preely User Testing for Sketch',
        hideTitleBar: true,
        shouldKeepAround: true,

        handlers: {
            getUserPrefs: function () {
                function getUserPrefs() {
                    webUI.eval("__sketchAPI('getUserPrefsResult', " + JSON.stringify(preferences) + ")");
                }

                return getUserPrefs;
            }(),

            setUserPrefs: function () {
                function setUserPrefs(values) {
                    preferences = JSON.parse(values);
                    _sketchModuleUserPreferences2['default'].setUserPreferences(options.identifier, preferences);
                    webUI.eval("__sketchAPI('setUserPrefsResult', " + JSON.stringify(preferences) + ")");
                }

                return setUserPrefs;
            }(),

            getDocPrefs: function () {
                function getDocPrefs() {
                    var docPrefs = context.command.valueForKey_onDocument_forPluginIdentifier("prefs", context.document.documentData(), options.identifier);

                    if (docPrefs === null) docPrefs = '{}';

                    webUI.eval("__sketchAPI('getDocPrefsResult', " + JSON.stringify(docPrefs) + ")");
                }

                return getDocPrefs;
            }(),

            setDocPrefs: function () {
                function setDocPrefs(values) {
                    context.command.setValue_forKey_onDocument_forPluginIdentifier(values, "prefs", context.document.documentData(), options.identifier);

                    webUI.eval("__sketchAPI('setDocPrefsResult', " + values + ")");
                }

                return setDocPrefs;
            }(),

            getSelectedArtboardsCount: function () {
                function getSelectedArtboardsCount() {
                    var count = _helper2['default'].getSelectedArtboardsCount(context.document.selectedLayers().layers());
                    webUI.eval("__sketchAPI('getSelectedArtboardsCountResult', " + count + ")");
                }

                return getSelectedArtboardsCount;
            }(),

            getSelectedArtboards: function () {
                function getSelectedArtboards() {
                    var selectedLayers = context.document.selectedLayers().layers();
                    var artboards = _helper2['default'].getSelectedArtboards(selectedLayers);
                    var details = [];

                    for (var a = 0; a < artboards.length; a++) {
                        details.push({
                            name: artboards[a].name() + '',
                            objectID: artboards[a].objectID() + ''
                        });
                    }
                    log('getSelectedArtboardsResult ' + JSON.stringify(details));

                    webUI.eval("__sketchAPI('getSelectedArtboardsResult', " + JSON.stringify(details) + ")");
                }

                return getSelectedArtboards;
            }(),

            exportArtbards: function () {
                function exportArtbards() {
                    var images = _helper2['default'].serializeArtboards(context);

                    webUI.eval("__sketchAPI('exportArtbardsResult', " + JSON.stringify(images) + ")");
                }

                return exportArtbards;
            }(),

            nativeLog: function () {
                function nativeLog(msg) {
                    log(msg);
                }

                return nativeLog;
            }(),

            nativeAlert: function () {
                function nativeAlert(alertObj) {
                    var alert = JSON.parse(alertObj);

                    NSApplication.sharedApplication().displayDialog_withTitle_(alert.message, alert.title);
                }

                return nativeAlert;
            }(),

            openUrl: function () {
                function openUrl(url) {
                    var url = NSURL.URLWithString(url);
                    NSWorkspace.sharedWorkspace().openURL(url) + '';
                }

                return openUrl;
            }(),

            close: function () {
                function close() {
                    webUI.panel.setIsVisible(false);
                    COScript.currentCOScript().setShouldKeepAround(false);
                }

                return close;
            }()

        },
        uiDelegate: {} // https://developer.apple.com/reference/webkit/webuidelegate?language=objc
    };

    log('====== Selection ');
    var selectedLayers = context.document.selectedLayers().layers();
    var enumerator = selectedLayers.objectEnumerator();
    var artboards = {};

    while (msLayer = enumerator.nextObject()) {
        if (!artboards.hasOwnProperty(msLayer.parentArtboard().objectID())) {
            artboards[msLayer.parentArtboard().objectID()] = msLayer.parentArtboard();
            log('++ selected artboard: ' + msLayer.parentArtboard().name());
        }
    }
    log('======');

    var preferences = _sketchModuleUserPreferences2['default'].getUserPreferences(options.identifier, defaultPreferences);

    var webUI = new _sketchModuleWebView2['default'](context, 'index.html', options);
};

var _sketchModuleWebView = __webpack_require__(1);

var _sketchModuleWebView2 = _interopRequireDefault(_sketchModuleWebView);

var _sketchModuleUserPreferences = __webpack_require__(4);

var _sketchModuleUserPreferences2 = _interopRequireDefault(_sketchModuleUserPreferences);

var _helper = __webpack_require__(5);

var _helper2 = _interopRequireDefault(_helper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

/* globals NSUUID NSThread NSPanel NSMakeRect NSTexturedBackgroundWindowMask NSTitledWindowMask NSWindowTitleHidden NSClosableWindowMask NSColor NSWindowMiniaturizeButton NSWindowZoomButton NSFloatingWindowLevel WebView COScript */
var MochaJSDelegate = __webpack_require__(2)
var parseQuery = __webpack_require__(3)

var coScript = COScript.currentCOScript()

var LOCATION_CHANGED = 'webView:didChangeLocationWithinPageForFrame:'

function WebUI (context, frameLocation, options) {
  // ColorPicker main window
  var identifier = options.identifier || NSUUID.UUID().UUIDString()
  var threadDictionary = NSThread.mainThread().threadDictionary()
  var backgroundColor = options.background || NSColor.whiteColor()
  var panel = threadDictionary[identifier] ? threadDictionary[identifier] : NSPanel.alloc().init()

  // Window size
  panel.setFrame_display(NSMakeRect(
    options.x || 0,
    options.y || 0,
    options.width || 240,
    options.height || 180
  ), true)

  // Titlebar
  panel.setTitle(options.title || context.plugin.name())
  if (options.hideTitleBar) {
    panel.setTitlebarAppearsTransparent(true)
    panel.setTitleVisibility(NSWindowTitleHidden)
  }

  // Hide minize and zoom buttons
  if (options.onlyShowCloseButton) {
    panel.standardWindowButton(NSWindowMiniaturizeButton).setHidden(true)
    panel.standardWindowButton(NSWindowZoomButton).setHidden(true)
  }

  // Close window callback
  if (options.onPanelClose) {
    var closeButton = panel.standardWindowButton(NSWindowCloseButton)
    closeButton.setCOSJSTargetFunction(function(sender) {
      options.onPanelClose()
      COScript.currentCOScript().setShouldKeepAround(false)
      threadDictionary.removeObjectForKey(options.identifier)
      panel.close()
    })
    closeButton.setAction("callAction:")
  }

  panel.setStyleMask(options.styleMask || (NSTexturedBackgroundWindowMask | NSTitledWindowMask | NSClosableWindowMask))
  panel.setBackgroundColor(backgroundColor)
  panel.becomeKeyWindow()
  panel.setLevel(NSFloatingWindowLevel)

  threadDictionary[identifier] = panel

  if (options.shouldKeepAround !== false) { // Long-running script
    coScript.setShouldKeepAround(true)
  }

  // Add Web View to window
  var webView = WebView.alloc().initWithFrame(NSMakeRect(
    0,
    options.hideTitleBar ? -24 : 0,
    options.width || 240,
    (options.height || 180) - (options.hideTitleBar ? 0 : 24)
  ))

  if (options.frameLoadDelegate || options.handlers) {
    var handlers = options.frameLoadDelegate || {}
    if (options.handlers) {
      var lastQueryId
      handlers[LOCATION_CHANGED] = function (webview, frame) {
        var query = webview.windowScriptObject().evaluateWebScript('window.location.hash')
        query = parseQuery(query)
        if (query.pluginAction && query.actionId && query.actionId !== lastQueryId && query.pluginAction in options.handlers) {
          lastQueryId = query.actionId
          try {
            query.pluginArgs = JSON.parse(query.pluginArgs)
          } catch (err) {}
          options.handlers[query.pluginAction].apply(context, query.pluginArgs)
        }
      }
    }
    var frameLoadDelegate = new MochaJSDelegate(handlers)
    webView.setFrameLoadDelegate_(frameLoadDelegate.getClassInstance())
  }
  if (options.uiDelegate) {
    var uiDelegate = new MochaJSDelegate(options.uiDelegate)
    webView.setUIDelegate_(uiDelegate.getClassInstance())
  }

  webView.setOpaque(true)
  webView.setBackgroundColor(backgroundColor)

  // When frameLocation is a file, prefix it with the Sketch Resources path
  if ((/^(?!http|localhost|www|file).*\.html?$/).test(frameLocation)) {
    frameLocation = context.plugin.urlForResourceNamed(frameLocation).path()
  }
  webView.setMainFrameURL_(frameLocation)

  panel.contentView().addSubview(webView)
  panel.center()
  panel.makeKeyAndOrderFront(null)

  return {
    panel: panel,
    eval: webView.stringByEvaluatingJavaScriptFromString,
    webView: webView
  }
}

WebUI.clean = function () {
  coScript.setShouldKeepAround(false)
}

module.exports = WebUI


/***/ }),
/* 2 */
/***/ (function(module, exports) {

/* globals NSUUID MOClassDescription NSObject NSSelectorFromString NSClassFromString */

module.exports = function (selectorHandlerDict, superclass) {
  var uniqueClassName = 'MochaJSDelegate_DynamicClass_' + NSUUID.UUID().UUIDString()

  var delegateClassDesc = MOClassDescription.allocateDescriptionForClassWithName_superclass_(uniqueClassName, superclass || NSObject)

  delegateClassDesc.registerClass()

  // Storage Handlers
  var handlers = {}

  // Define interface
  this.setHandlerForSelector = function (selectorString, func) {
    var handlerHasBeenSet = (selectorString in handlers)
    var selector = NSSelectorFromString(selectorString)

    handlers[selectorString] = func

    /*
      For some reason, Mocha acts weird about arguments: https://github.com/logancollins/Mocha/issues/28
      We have to basically create a dynamic handler with a likewise dynamic number of predefined arguments.
    */
    if (!handlerHasBeenSet) {
      var args = []
      var regex = /:/g
      while (regex.exec(selectorString)) {
        args.push('arg' + args.length)
      }

      var dynamicFunction = eval('(function (' + args.join(', ') + ') { return handlers[selectorString].apply(this, arguments); })')

      delegateClassDesc.addInstanceMethodWithSelector_function_(selector, dynamicFunction)
    }
  }

  this.removeHandlerForSelector = function (selectorString) {
    delete handlers[selectorString]
  }

  this.getHandlerForSelector = function (selectorString) {
    return handlers[selectorString]
  }

  this.getAllHandlers = function () {
    return handlers
  }

  this.getClass = function () {
    return NSClassFromString(uniqueClassName)
  }

  this.getClassInstance = function () {
    return NSClassFromString(uniqueClassName).new()
  }

  // Convenience
  if (typeof selectorHandlerDict === 'object') {
    for (var selectorString in selectorHandlerDict) {
      this.setHandlerForSelector(selectorString, selectorHandlerDict[selectorString])
    }
  }
}


/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = function (query) {
  query = query.split('?')[1]
  if (!query) { return }
  query = query.split('&').reduce(function (prev, s) {
    var res = s.split('=')
    if (res.length === 2) {
      prev[decodeURIComponent(res[0])] = decodeURIComponent(res[1])
    }
    return prev
  }, {})
  return query
}


/***/ }),
/* 4 */
/***/ (function(module, exports) {

const SUITE_PREFIX = 'plugin.sketch.'

function isPresent (data) {
  return data != null
}

module.exports = {
  getUserPreferences: function (pluginName, defaultPrefs) {
    var prefs = {}
    var store = NSUserDefaults.alloc().initWithSuiteName(SUITE_PREFIX + pluginName)
    Object.keys(defaultPrefs).forEach(function (k) {
      if (typeof defaultPrefs[k] === 'boolean') {
        prefs[k] = isPresent(store.boolForKey(k)) ? Boolean(store.boolForKey(k)) : defaultPrefs[k]
      } else if (typeof defaultPrefs[k] === 'number') {
        prefs[k] = isPresent(store.doubleForKey(k)) ? store.doubleForKey(k) : defaultPrefs[k]
      } else if (typeof defaultPrefs[k] === 'string') {
        prefs[k] = isPresent(store.stringForKey(k)) ? '' + store.stringForKey(k) : defaultPrefs[k]
      } else if (Array.isArray(defaultPrefs[k])) {
        prefs[k] = store.arrayForKey(k) || defaultPrefs[k]
      } else {
        prefs[k] = store.dictionaryForKey(k) || defaultPrefs[k]
      }
    })
    return prefs
  },
  setUserPreferences: function (pluginName, prefs) {
    var store = NSUserDefaults.alloc().initWithSuiteName(SUITE_PREFIX + pluginName)
    Object.keys(prefs).forEach(function (k) {
      if (typeof prefs[k] === 'boolean') {
        store.setBool_forKey(prefs[k], k)
      } else if (typeof prefs[k] === 'number') {
        store.setDouble_forKey(prefs[k], k)
      } else {
        store.setObject_forKey(prefs[k], k)
      }
    })
    store.synchronize()
  }
}


/***/ }),
/* 5 */
/***/ (function(module, exports) {

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Helper = function () {
    function Helper() {
        _classCallCheck(this, Helper);
    }

    _createClass(Helper, null, [{
        key: 'getWebViewReference',
        value: function () {
            function getWebViewReference() {
                var threadDictionary = NSThread.mainThread().threadDictionary();
                var panel = threadDictionary['preely-sketch-plugin.webview'];

                if (panel === null) return null;

                var subviews = panel.contentView().subviews();

                refs = [];
                for (var v = 0; v < subviews.length; v++) {
                    if (subviews[v].className() == 'WebView') {
                        refs.push({
                            panel: panel,
                            eval: subviews[v].stringByEvaluatingJavaScriptFromString,
                            webView: subviews[v]
                        });
                    }
                }

                return refs;
            }

            return getWebViewReference;
        }()
    }, {
        key: 'getSelectedArtboards',
        value: function () {
            function getSelectedArtboards(selection) {
                var enumerator = selection.objectEnumerator();
                var artboards = {};

                while (msLayer = enumerator.nextObject()) {
                    if (!artboards.hasOwnProperty(msLayer.parentArtboard().objectID())) {
                        artboards[msLayer.parentArtboard().objectID()] = msLayer.parentArtboard();
                    }
                }

                return Object.values(artboards);
            }

            return getSelectedArtboards;
        }()
    }, {
        key: 'getSelectedArtboardsCount',
        value: function () {
            function getSelectedArtboardsCount(selection) {
                return Helper.getSelectedArtboards(selection).length;
            }

            return getSelectedArtboardsCount;
        }()
    }, {
        key: 'artboardsInSelection',
        value: function () {
            function artboardsInSelection(selection) {
                return Helper.getSelectedArtboardsCount(selection) > 0;
            }

            return artboardsInSelection;
        }()
    }, {
        key: 'getArtboardsInPage',
        value: function () {
            function getArtboardsInPage(page) {
                var artboardObjects = page.artboards().objectEnumerator();
                var artboards = [];

                while (artboard = artboardObjects.nextObject()) {
                    artboards.push(artboard);
                }

                return artboards;
            }

            return getArtboardsInPage;
        }()
    }, {
        key: 'serializeArtboards',
        value: function () {
            function serializeArtboards(ctx) {
                var document = ctx.document;

                var selectedLayers = ctx.document.selectedLayers().layers();
                var artboards = Helper.getSelectedArtboards(selectedLayers);

                if (artboards.length === 0) {
                    artboards = Helper.getArtboardsInPage(document.currentPage());
                }

                var images = [];

                for (var i = 0; i < artboards.length; i++) {
                    var artboard = artboards[i];

                    var filename = artboard.name() + ".png";
                    var path = NSTemporaryDirectory() + artboard.objectID() + '.png';
                    //save file to temp path
                    var request = MSExportRequest['new']();
                    request.format = 'png';
                    request.includeArtboardBackground = true;
                    request.rect = artboard.absoluteInfluenceRect();
                    request.scale = 2;

                    document.saveExportRequest_toFile(request, path);

                    var image = NSData.alloc().initWithContentsOfURL(NSURL.fileURLWithPath(path));
                    var imageData = image.base64EncodedStringWithOptions(0);

                    images.push({
                        name: filename,
                        data: 'data:image/png;base64,' + imageData
                    });
                }

                return images;
            }

            return serializeArtboards;
        }()
    }]);

    return Helper;
}();

exports['default'] = Helper;

/***/ })
/******/ ]);
  if (key === 'default' && typeof exports === 'function') {
    exports(context);
  } else {
    exports[key](context);
  }
}
that['onRun'] = __skpm_run.bind(this, 'default')
